From aec3f24fb1241ae4dbccacd01b069d0510b18b2b Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 02 2021 21:14:58 +0000
Subject: [PATCH 1980/2232] Merge pull request #644 from dtolnay/result


Decouple C++ exception representation from Rust str
---

diff --git a/src/result.rs b/src/result.rs
index 29c5d67..7927c20 100644
--- a/src/result.rs
+++ b/src/result.rs
@@ -1,16 +1,22 @@
 use crate::exception::Exception;
-use crate::rust_str::RustStr;
 use alloc::boxed::Box;
 use alloc::string::{String, ToString};
 use core::fmt::Display;
-use core::ptr;
+use core::ptr::{self, NonNull};
 use core::result::Result as StdResult;
 use core::slice;
 use core::str;
 
 #[repr(C)]
+#[derive(Copy, Clone)]
+struct PtrLen {
+    ptr: NonNull<u8>,
+    len: usize,
+}
+
+#[repr(C)]
 pub union Result {
-    err: RustStr,
+    err: PtrLen,
     ok: *const u8, // null
 }
 
@@ -41,7 +47,10 @@ unsafe fn to_c_error(msg: String) -> Result {
     let copy = error(ptr, len);
     let slice = slice::from_raw_parts(copy, len);
     let string = str::from_utf8_unchecked(slice);
-    let err = RustStr::from(string);
+    let err = PtrLen {
+        ptr: NonNull::from(string).cast::<u8>(),
+        len: string.len(),
+    };
     Result { err }
 }
 

